// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VrScrollText.pas' rev: 6.00

#ifndef VrScrollTextHPP
#define VrScrollTextHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VrThreads.hpp>	// Pascal unit
#include <VrControls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vrscrolltext
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TScrollDirection { sdLeftToRight, sdRightToLeft };
#pragma option pop

#pragma option push -b-
enum TScrollOffset { soCentered, soOutOfView };
#pragma option pop

#pragma option push -b-
enum TEdgeStyle { esLeft, esRight, esBoth };
#pragma option pop

class DELPHICLASS TVrScrollText;
class PASCALIMPLEMENTATION TVrScrollText : public Vrcontrols::TVrGraphicImageControl 
{
	typedef Vrcontrols::TVrGraphicImageControl inherited;
	
private:
	Vrthreads::TVrTimer* FTimer;
	bool FActive;
	Graphics::TBitmap* FBackBitmap;
	Graphics::TBitmap* FWholeBitmap;
	int FPosition;
	TScrollDirection FScrollDirection;
	int FEdgeWidth;
	TEdgeStyle FEdgeStyle;
	int FPixelStep;
	int __fastcall GetInterval(void);
	bool __fastcall GetThreaded(void);
	void __fastcall SetEdgeWidth(const int Value);
	void __fastcall SetEdgeStyle(TEdgeStyle Value);
	void __fastcall SetScrollDirection(const TScrollDirection Value);
	void __fastcall SetActive(bool Value);
	void __fastcall SetThreaded(bool Value);
	void __fastcall SetInterval(int Value);
	void __fastcall TimerEvent(System::TObject* Sender);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMColorChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMTextChanged(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall Loaded(void);
	void __fastcall InvalidateBitmaps(void);
	Graphics::TColor __fastcall CalcColorIndex(Graphics::TColor StartColor, Graphics::TColor EndColor, int Steps, int ColorIndex);
	
public:
	__fastcall virtual TVrScrollText(Classes::TComponent* AOwner);
	__fastcall virtual ~TVrScrollText(void);
	DYNAMIC void __fastcall Resize(void);
	
__published:
	__property bool Threaded = {read=GetThreaded, write=SetThreaded, nodefault};
	__property int Interval = {read=GetInterval, write=SetInterval, default=50};
	__property int EdgeWidth = {read=FEdgeWidth, write=SetEdgeWidth, default=15};
	__property TEdgeStyle EdgeStyle = {read=FEdgeStyle, write=SetEdgeStyle, default=2};
	__property TScrollDirection ScrollDirection = {read=FScrollDirection, write=SetScrollDirection, default=0};
	__property int PixelStep = {read=FPixelStep, write=FPixelStep, default=1};
	__property bool Active = {read=FActive, write=SetActive, default=0};
	__property Caption ;
	__property Font ;
	__property Color  = {default=-2147483643};
	__property ParentFont  = {default=1};
	__property ParentColor  = {default=1};
	__property Visible  = {default=1};
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnClick ;
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Vrscrolltext */
using namespace Vrscrolltext;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VrScrollText
