// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'vrLedClock.pas' rev: 6.00

#ifndef vrLedClockHPP
#define vrLedClockHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <VrThreads.hpp>	// Pascal unit
#include <VrSysUtils.hpp>	// Pascal unit
#include <VrControls.hpp>	// Pascal unit
#include <VrClasses.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vrledclock
{
//-- type declarations -------------------------------------------------------
typedef Shortint TVrHoursInt;

typedef Shortint TVrMinutesInt;

typedef Shortint TVrSecondsInt;

#pragma option push -b-
enum TVrHourFormat { hfmt24h, hfmt12h };
#pragma option pop

class DELPHICLASS TVrLedClock;
class PASCALIMPLEMENTATION TVrLedClock : public Vrcontrols::TVrGraphicImageControl 
{
	typedef Vrcontrols::TVrGraphicImageControl inherited;
	
private:
	bool FActive;
	bool FSecondsIndicator;
	bool FHourMarks;
	TVrHoursInt FHours;
	TVrMinutesInt FMinutes;
	TVrSecondsInt FSeconds;
	Graphics::TBitmap* FBackground;
	Graphics::TColor FHoursColor;
	Graphics::TColor FHoursOutline;
	Graphics::TColor FSecHandColor;
	Graphics::TColor FSecOutline;
	Graphics::TColor FTickColor;
	int FTickWidth;
	Graphics::TColor FTickOutline;
	System::TDateTime FAlarmTime;
	bool FEnableAlarm;
	Classes::TNotifyEvent FOnAlarm;
	Vrcontrols::TVrHoursChangeEvent FOnHoursChanged;
	Vrcontrols::TVrMinutesChangeEvent FOnMinutesChanged;
	Vrcontrols::TVrSecondsChangeEvent FOnSecondsChanged;
	Vrthreads::TVrTimer* FTimer;
	int FSecWidth;
	int FLedSize;
	int FSpacing;
	int FTextOffsetX;
	int FTextOffsetY;
	int FTextAngle;
	System::TDateTime FTime;
	TVrHourFormat FHourFormat;
	bool __fastcall GetThreaded(void);
	void __fastcall SetActive(bool Value);
	void __fastcall SetSecondsIndicator(bool Value);
	void __fastcall SetHourMarks(bool Value);
	void __fastcall SetBackground(Graphics::TBitmap* Value);
	void __fastcall SetHoursColor(Graphics::TColor Value);
	void __fastcall SetSecHandColor(Graphics::TColor Value);
	void __fastcall SetSecOutline(Graphics::TColor Value);
	void __fastcall SetTickColor(Graphics::TColor Value);
	void __fastcall SetTickWidth(int Value);
	void __fastcall SetTickOutline(Graphics::TColor Value);
	void __fastcall SetThreaded(bool Value);
	void __fastcall OnTimerEvent(System::TObject* Sender);
	void __fastcall SetSecWidth(int Value);
	void __fastcall SetHours(TVrHoursInt Value);
	void __fastcall SetMinutes(TVrMinutesInt Value);
	void __fastcall SetSeconds(TVrSecondsInt Value);
	void __fastcall SetLedSize(int Value);
	void __fastcall SetSpacing(int Value);
	void __fastcall SetTextOffsetX(int Value);
	void __fastcall SetTextOffsety(int Value);
	void __fastcall SetHoursOutline(Graphics::TColor Value);
	void __fastcall SetTextAngle(const int Value);
	void __fastcall SetTime(const System::TDateTime Value);
	void __fastcall SetHourFormat(const TVrHourFormat Value);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall HoursChanged(void);
	virtual void __fastcall MinutesChanged(void);
	virtual void __fastcall SecondsChanged(void);
	void __fastcall DoAlarm(void);
	void __fastcall PaintLed(int X, int Y, char Ch);
	void __fastcall DrawLeds(void);
	
public:
	__fastcall virtual TVrLedClock(Classes::TComponent* AOwner);
	__fastcall virtual ~TVrLedClock(void);
	virtual void __fastcall Loaded(void);
	__property System::TDateTime AlarmTime = {read=FAlarmTime, write=FAlarmTime};
	__property System::TDateTime Time = {read=FTime, write=SetTime};
	
__published:
	__property bool Threaded = {read=GetThreaded, write=SetThreaded, nodefault};
	__property bool Active = {read=FActive, write=SetActive, default=0};
	__property bool SecondsIndicator = {read=FSecondsIndicator, write=SetSecondsIndicator, default=1};
	__property bool HourMarks = {read=FHourMarks, write=SetHourMarks, default=1};
	__property Graphics::TBitmap* Background = {read=FBackground, write=SetBackground};
	__property Graphics::TColor HoursColor = {read=FHoursColor, write=SetHoursColor, default=255};
	__property Graphics::TColor HoursOutline = {read=FHoursOutline, write=SetHoursOutline, default=255};
	__property Graphics::TColor SecHandColor = {read=FSecHandColor, write=SetSecHandColor, default=255};
	__property Graphics::TColor SecOutline = {read=FSecOutline, write=SetSecOutline, default=255};
	__property int SecWidth = {read=FSecWidth, write=SetSecWidth, default=2};
	__property Graphics::TColor TickColor = {read=FTickColor, write=SetTickColor, default=255};
	__property Graphics::TColor TickOutline = {read=FTickOutline, write=SetTickOutline, default=255};
	__property int TickWidth = {read=FTickWidth, write=SetTickWidth, default=2};
	__property bool EnableAlarm = {read=FEnableAlarm, write=FEnableAlarm, default=0};
	__property TVrHoursInt Hours = {read=FHours, write=SetHours, nodefault};
	__property TVrHourFormat HourFormat = {read=FHourFormat, write=SetHourFormat, nodefault};
	__property TVrMinutesInt Minutes = {read=FMinutes, write=SetMinutes, nodefault};
	__property TVrSecondsInt Seconds = {read=FSeconds, write=SetSeconds, nodefault};
	__property int LedSize = {read=FLedSize, write=SetLedSize, default=5};
	__property int Spacing = {read=FSpacing, write=SetSpacing, default=6};
	__property int TextOffsetX = {read=FTextOffsetX, write=SetTextOffsetX, default=0};
	__property int TextOffsetY = {read=FTextOffsetY, write=SetTextOffsety, default=0};
	__property int TextAngle = {read=FTextAngle, write=SetTextAngle, default=10};
	__property Classes::TNotifyEvent OnAlarm = {read=FOnAlarm, write=FOnAlarm};
	__property Vrcontrols::TVrHoursChangeEvent OnHoursChanged = {read=FOnHoursChanged, write=FOnHoursChanged};
	__property Vrcontrols::TVrMinutesChangeEvent OnMinutesChanged = {read=FOnMinutesChanged, write=FOnMinutesChanged};
	__property Vrcontrols::TVrSecondsChangeEvent OnSecondsChanged = {read=FOnSecondsChanged, write=FOnSecondsChanged};
	__property Transparent  = {default=0};
	__property Align  = {default=0};
	__property Anchors  = {default=3};
	__property Constraints ;
	__property Color  = {default=0};
	__property DragCursor  = {default=-12};
	__property DragKind  = {default=0};
	__property DragMode  = {default=0};
	__property Hint ;
	__property ParentColor  = {default=0};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible  = {default=1};
	__property Version ;
	__property OnClick ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDock ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDock ;
	__property OnStartDrag ;
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Vrledclock */
using namespace Vrledclock;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// vrLedClock
